<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Crazyflie plugin for ARGoS: src/plugins/robots/crazyflie/simulator/crazyflie_entity.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Crazyflie plugin for ARGoS
   </div>
   <div id="projectbrief">ADARS project -- PCOG / SnT / University of Luxembourg</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_7020b8b7abcceffa3f9f7a2d24718f16.html">plugins</a></li><li class="navelem"><a class="el" href="dir_57fbab4b29583c403f1efb5284ea3eb3.html">robots</a></li><li class="navelem"><a class="el" href="dir_82540c9fcfb987b606f5fb531cb7ce0a.html">crazyflie</a></li><li class="navelem"><a class="el" href="dir_8f67be75dbc917b3ef586b0672f32ede.html">simulator</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">crazyflie_entity.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="crazyflie__entity_8h_source.html">crazyflie_entity.h</a>&quot;</code><br />
<code>#include &lt;argos3/core/simulator/space/space.h&gt;</code><br />
<code>#include &lt;argos3/core/simulator/entity/controllable_entity.h&gt;</code><br />
<code>#include &lt;argos3/core/simulator/entity/embodied_entity.h&gt;</code><br />
<code>#include &lt;argos3/plugins/simulator/entities/led_equipped_entity.h&gt;</code><br />
<code>#include &lt;argos3/plugins/simulator/entities/quadrotor_entity.h&gt;</code><br />
<code>#include &lt;argos3/plugins/simulator/entities/rab_equipped_entity.h&gt;</code><br />
<code>#include &quot;<a class="el" href="crazyflie__camera__equipped__entity_8h_source.html">crazyflie_camera_equipped_entity.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="crazyflie__battery__equipped__entity_8h_source.html">crazyflie_battery_equipped_entity.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for crazyflie_entity.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="crazyflie__entity_8cpp__incl.png" border="0" usemap="#asrc_2plugins_2robots_2crazyflie_2simulator_2crazyflie__entity_8cpp" alt=""/></div>
<map name="asrc_2plugins_2robots_2crazyflie_2simulator_2crazyflie__entity_8cpp" id="asrc_2plugins_2robots_2crazyflie_2simulator_2crazyflie__entity_8cpp">
<area shape="rect" title=" " alt="" coords="592,5,729,61"/>
<area shape="rect" href="crazyflie__entity_8h.html" title=" " alt="" coords="36,124,155,151"/>
<area shape="rect" title=" " alt="" coords="179,117,326,158"/>
<area shape="rect" title=" " alt="" coords="350,109,497,165"/>
<area shape="rect" title=" " alt="" coords="379,221,545,262"/>
<area shape="rect" title=" " alt="" coords="978,109,1141,165"/>
<area shape="rect" title=" " alt="" coords="1165,117,1340,158"/>
<area shape="rect" title=" " alt="" coords="1365,109,1527,165"/>
<area shape="rect" href="crazyflie__camera__equipped__entity_8h.html" title=" " alt="" coords="773,117,953,158"/>
<area shape="rect" href="crazyflie__battery__equipped__entity_8h.html" title=" " alt="" coords="572,117,749,158"/>
<area shape="rect" title=" " alt="" coords="5,221,185,262"/>
<area shape="rect" title=" " alt="" coords="790,221,937,262"/>
<area shape="rect" title=" " alt="" coords="1115,213,1281,269"/>
<area shape="rect" title=" " alt="" coords="641,221,766,262"/>
<area shape="rect" title=" " alt="" coords="961,221,1091,262"/>
<area shape="rect" title=" " alt="" coords="569,228,616,255"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespaceargos"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceargos.html">argos</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:acc87d83df62d9f95fb7916e095ded9b4"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="crazyflie__entity_8cpp.html#acc87d83df62d9f95fb7916e095ded9b4">UPDATE</a>(COMPONENT)&#160;&#160;&#160;if(COMPONENT-&gt;IsEnabled()) COMPONENT-&gt;Update();</td></tr>
<tr class="separator:acc87d83df62d9f95fb7916e095ded9b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a17799cc6e40474a041d229dfb7e306c1"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceargos.html#a17799cc6e40474a041d229dfb7e306c1">argos::REGISTER_ENTITY</a> (CCrazyflieEntity, &quot;crazyflie&quot;, &quot;Daniel H. Stolfi based on the Carlo Pinciroli's work&quot;, &quot;1.0&quot;, &quot;The crazyflie drone, developed by Bitcraze.&quot;, &quot;The crazyflie is a quad-rotor developed by Bitcraze. It is a\n&quot; &quot;fully autonomous drone with four propellers and a single bottom led.\n\n&quot; &quot;REQUIRED XML CONFIGURATION\n\n&quot; &quot;  &lt;arena ...&gt;\n&quot; &quot;    ...\n&quot; &quot;    &lt;crazyflie id=\&quot;cf0\&quot;&gt;\n&quot; &quot;      &lt;body position=\&quot;0.4,2.3,0.25\&quot; orientation=\&quot;45,0,0\&quot; /&gt;\n&quot; &quot;      &lt;controller config=\&quot;mycntrl\&quot; /&gt;\n&quot; &quot;    &lt;/crazyflie&gt;\n&quot; &quot;    ...\n&quot; &quot;  &lt;/arena&gt;\n\n&quot; &quot;The 'id' attribute is necessary and must be unique among the entities. If two\n&quot; &quot;entities share the same id, initialization aborts.\n&quot; &quot;The 'body/position' attribute specifies the position of the bottom point of the\n&quot; &quot;crazyflie in the arena.\n&quot; &quot;The 'body/orientation' attribute specifies the orientation of the crazyflie. All\n&quot; &quot;rotations are performed with respect to the bottom point. The order of the\n&quot; &quot;angles is Z,Y,X, which means that the first number corresponds to the rotation\n&quot; &quot;around the Z axis, the second around Y and the last around X. This reflects\n&quot; &quot;the internal convention used in ARGoS, in which rotations are performed in\n&quot; &quot;that order. Angles are expressed in degrees. When the drone is unrotated, it\n&quot; &quot;is oriented along the X axis.\n&quot; &quot;The 'controller/config' attribute is used to assign a controller to the\n&quot; &quot;crazyflie. The value of the attribute must be set to the id of a previously\n&quot; &quot;defined controller. Controllers are defined in the &lt;controllers&gt; XML subtree.\n\n&quot; &quot;OPTIONAL XML CONFIGURATION\n\n&quot; &quot;You can set the emission range of the range-and-bearing system. By default, a\n&quot; &quot;message sent by an crazyflie can be received up to 3m. By using the 'rab_range'\n&quot; &quot;attribute, you can change it to, i.e., 4m as follows:\n\n&quot; &quot;  &lt;arena ...&gt;\n&quot; &quot;    ...\n&quot; &quot;    &lt;crazyflie id=\&quot;cf0\&quot; rab_range=\&quot;4\&quot;&gt;\n&quot; &quot;      &lt;body position=\&quot;0.4,2.3,0.25\&quot; orientation=\&quot;45,0,0\&quot; /&gt;\n&quot; &quot;      &lt;controller config=\&quot;mycntrl\&quot; /&gt;\n&quot; &quot;    &lt;/crazyflie&gt;\n&quot; &quot;    ...\n&quot; &quot;  &lt;/arena&gt;\n\n&quot; &quot;You can also set the data sent at each time step through the range-and-bearing\n&quot; &quot;system. By default, a message sent by a crazyflie is 10 bytes long. By using the\n&quot; &quot;'rab_data_size' attribute, you can change it to, i.e., 20 bytes as follows:\n\n&quot; &quot;  &lt;arena ...&gt;\n&quot; &quot;    ...\n&quot; &quot;    &lt;crazyflie id=\&quot;cf0\&quot; rab_data_size=\&quot;20\&quot;&gt;\n&quot; &quot;      &lt;body position=\&quot;0.4,2.3,0.25\&quot; orientation=\&quot;45,0,0\&quot; /&gt;\n&quot; &quot;      &lt;controller config=\&quot;mycntrl\&quot; /&gt;\n&quot; &quot;    &lt;/crazyflie&gt;\n&quot; &quot;    ...\n&quot; &quot;  &lt;/arena&gt;\n\n&quot; &quot;You can also configure the battery of the robot. By default, the battery never\n&quot; &quot;depletes. You can also define the battery's initial charge.\n\n&quot; &quot;  &lt;arena ...&gt;\n&quot; &quot;    ...\n&quot; &quot;    &lt;crazyflie id=\&quot;cf0\&quot;\n&quot; &quot;      &lt;body position=\&quot;0.4,2.3,0.25\&quot; orientation=\&quot;45,0,0\&quot; /&gt;\n&quot; &quot;      &lt;controller config=\&quot;mycntrl\&quot; /&gt;\n&quot; &quot;      &lt;crazyflie_battery start_charge=\&quot;0.8\&quot;/&gt;\n&quot; &quot;    &lt;/crazyflie&gt;\n&quot; &quot;    ...\n&quot; &quot;  &lt;/arena&gt;\n\n&quot;, &quot;Usable&quot;)</td></tr>
<tr class="separator:a17799cc6e40474a041d229dfb7e306c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb1b849098ae99824bab846a63545bb5"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceargos.html#abb1b849098ae99824bab846a63545bb5">argos::REGISTER_STANDARD_SPACE_OPERATIONS_ON_COMPOSABLE</a> (CCrazyflieEntity)</td></tr>
<tr class="separator:abb1b849098ae99824bab846a63545bb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="acc87d83df62d9f95fb7916e095ded9b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acc87d83df62d9f95fb7916e095ded9b4">&#9670;&nbsp;</a></span>UPDATE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define UPDATE</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">COMPONENT</td><td>)</td>
          <td>&#160;&#160;&#160;if(COMPONENT-&gt;IsEnabled()) COMPONENT-&gt;Update();</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
